close all;
clear all;
I = imread('tito.bmp');
figure, imshow(I), title('Imagem Original');
threshold = graythresh(I);
BWs = im2bw(I,threshold);
figure, imshow(BWs), title('Limiar');
se90 = strel('line', 8, 90);
se0 = strel('line', 8, 0);
BWsdil = imdilate(BWs, [se90 se0]);
figure, imshow(BWsdil), title('Imagem Dilatada');
seD = strel('diamond',2);
BWfinal = imerode(BWsdil,seD);
BWfinal = imerode(BWfinal,seD);
figure, imshow(BWfinal), title('Imagem Segmentada');
BWfinal = not(BWfinal);
BW = BWfinal > 0;
L = bwlabel(BW);
figure, imshow(label2rgb(L)), title('Poros Classificados');

s = regionprops(L, I, {'Centroid','PixelValues','BoundingBox'});
s2 = regionprops(L, {'MajorAxisLength'});
s3 = regionprops(L, {'MinorAxisLength'});
figure, imshow(I);
title('Comprimento do MAIOR EIXO (mm)');
hold on
numObj = numel(s);
for k = 1 : numObj
    text(s(k).Centroid(1),s(k).Centroid(2), sprintf('%2.3f', (s2(k).MajorAxisLength)/124.7), 'EdgeColor','b','Color','g'); % cada 10mm tem 1247 pixels
end
hold off

figure, imshow(I);
title('Comprimento do MENOR EIXO (mm)');
hold on
for k = 1 : numObj
    text(s(k).Centroid(1),s(k).Centroid(2), sprintf('%2.3f', (s3(k).MinorAxisLength)/124.7), 'EdgeColor','b','Color','g');
end
hold off
